/******************************
*	Author: Chris @ PyroElectro.com
*	Date:	4/27/2011
*
*	Description:
*	This program transmits USART output commands in
*   the form of 'L0', 'L1' or 'L2' depending upon the
*	state of PORTD bits 0 and 1.
*
*	This firmware is meant to be paired with the rf_rx
*	firmware for the tutorial located here:
*	http://www.pyroelectro.com/tutorials/wireless_interface_rf_modules/
*
******************************/

#include <p18f452.h>
#include <usart.h>
#include <delays.h>

void main(void)
{

//PORTD RD0 and RD1 Used For Button Input
	TRISD = 0x0F;

//PORTC Bit 6 Is TX (PIN 25)
	TRISCbits.TRISC6 = 0;
//PORTC Bit 6 Is RX (PIN 26)
	TRISCbits.TRISC7 = 1;

//Short Pause
	Delay10KTCYx(250);

//Configure USART
  OpenUSART( USART_TX_INT_OFF  &
             USART_RX_INT_OFF  &
             USART_ASYNCH_MODE &
             USART_EIGHT_BIT   &
             USART_CONT_RX     &
             USART_BRGH_LOW, 207 );

//Short Pause
	Delay10KTCYx(250);

  while(1)
  {

	//Inputs Are Active Low

//********Button/Command Output Control************
//*************************************************
//If No Button Pressed, Send Command L0
	if(PORTDbits.RD0 == 1 &&
	   PORTDbits.RD1 == 1){
	//Turn LED ON
    putcUSART( '0' );       //write value of PORTD
	Delay10KTCYx(10);
    putcUSART( 'L' );       //write value of PORTD
	Delay10KTCYx(10);
	}
//If Button #1 Is Pressed, Send Command L1
	else if(PORTDbits.RD0 == 0 &&
		    PORTDbits.RD1 == 1){
	//Turn LED OFF
    putcUSART( '1' );       //write value of PORTD
	Delay10KTCYx(10);
    putcUSART( 'L' );       //write value of PORTD
	Delay10KTCYx(10);
	}
//If Button #2 Is Pressed, Send Command L2
	else if(PORTDbits.RD0 == 1 &&
		    PORTDbits.RD1 == 0){
	//Turn LED OFF
    putcUSART( '2' );       //write value of PORTD
	Delay10KTCYx(10);
    putcUSART( 'L' );       //write value of PORTD
	Delay10KTCYx(10);
//*************************************************
	}
  }

  CloseUSART();
}